/*
	ARMADILLO SCANNER
	status: working ok (up to date)
*/

#include "packers.h"
#include "win.h"



/*
	IsArmaKey() identifies armadillo keys.
*/
bool IsArmaKey(HKEY, char*);



/*
	ScanArma() scans the registry and the temp files
	looking for Armadillo-generated rubbish.
*/

void ScanArma()
{
	SetStatus("scanning... (Armadillo)");



	// REGISTRY SCAN, VARIABLE KEYS (works ok)

	char* buf  = new char[BUFSIZE];
	char* buf2 = new char[BUFSIZE];
	DWORD size = BUFSIZE;
	FILETIME last;
	HKEY basekey;



	// scanning HKCR\CLSID

	RegOpenKeyEx(HKEY_CLASSES_ROOT,"CLSID\\",0,KEY_ALL_ACCESS,&basekey);

	int i=0,j=0;
	while(RegEnumKeyEx(basekey,i,buf,&size,0,NULL,NULL,&last)!=ERROR_NO_MORE_ITEMS)
	{
		if (IsArmaKey(basekey,buf))
		{
			wsprintf(buf2,"rkey::HKCR\\CLSID\\%s",buf);
			AddVal(ARMA,buf2);
		}

		size = BUFSIZE;
		i++;
	}

	RegCloseKey(basekey);



	// scanning HKCU\SOFTWARE\Classes

	RegOpenKeyEx(HKEY_CURRENT_USER,"SOFTWARE\\Classes",0,KEY_ALL_ACCESS,&basekey);

	i=0,j=0;
	while(RegEnumKeyEx(basekey,i,buf,&size,0,NULL,NULL,&last)!=ERROR_NO_MORE_ITEMS)
	{
		if (IsArmaKey(basekey,buf))
		{
			wsprintf(buf2,"rkey::HKCU\\CLSID\\%s",buf);
			AddVal(ARMA,buf2);
		}

		size = BUFSIZE;
		i++;
	}

	RegCloseKey(basekey);



	// REGISTRY SCAN, FIXED KEYS (works ok)

	if (RegOpenKeyEx(HKEY_CURRENT_USER,"SOFTWARE\\The Silicon Realms Toolworks\\Armadillo",0,KEY_ALL_ACCESS,&basekey)==ERROR_SUCCESS)
	{
		AddVal(ARMA,"rkey::HKCU\\SOFTWARE\\The Silicon Realms Toolworks\\Armadillo");
		RegCloseKey(basekey);
	}

	if (RegOpenKeyEx(HKEY_LOCAL_MACHINE,"SOFTWARE\\The Silicon Realms Toolworks\\Armadillo",0,KEY_ALL_ACCESS,&basekey)==ERROR_SUCCESS)
	{
		AddVal(ARMA,"rkey::HKLM\\SOFTWARE\\The Silicon Realms Toolworks\\Armadillo");
		RegCloseKey(basekey);
	}
	
	if (RegOpenKeyEx(HKEY_LOCAL_MACHINE,"SOFTWARE\\Licenses",0,KEY_ALL_ACCESS,&basekey)==ERROR_SUCCESS)
	{
		AddVal(ARMA,"rkey::HKLM\\SOFTWARE\\Licenses");
		RegCloseKey(basekey);
	}



	// TEMP FILES SCAN (works ok)

	GetTempPath(BUFSIZE,buf);
	wsprintf(buf2,"%s*.tmp",buf);
	WIN32_FIND_DATA fdata;
	HANDLE sh = FindFirstFile(buf2,&fdata);

	if (sh!=INVALID_HANDLE_VALUE)
	{
		if (fdata.cFileName[0]!='~' && strlen(fdata.cFileName)==12)
		{
			wsprintf(buf2,"file::%s%s",buf,fdata.cFileName);
			AddVal(ARMA,buf2);
		}
		while (FindNextFile(sh,&fdata))
		{
			if (fdata.cFileName[0]!='~' && strlen(fdata.cFileName)==12)
			{
				wsprintf(buf2,"file::%s%s",buf,fdata.cFileName);
				AddVal(ARMA,buf2);
			}
		}
		FindClose(sh);
	}



	// SCAN FINISHED

	delete[] buf;
	delete[] buf2;

	SetStatusReady();
}

bool IsArmaKey(HKEY base, char* keyname)
{
	HKEY sub;

	if (keyname[0] == '{')
	{
		if (RegOpenKeyEx(base,keyname,0,KEY_ALL_ACCESS,&sub)==ERROR_SUCCESS)
		{
			if (RegQueryValueEx(sub,"0",0,NULL,NULL,NULL)==ERROR_SUCCESS)
			{
				CloseHandle(sub);
				return true;
			}
			else
			{
				CloseHandle(sub);
				return false;
			}
		}
		else return false;
	}
	else return false;
}