/*
	ASPROTECT SCANNER
	status: working ok (up to date)
*/

#include "packers.h"
#include "win.h"



/*
	IsAsprKey() identifies asprotect keys.
*/
bool IsAsprKey(HKEY, char*, char*);



/*
	ScanAspr() scans the registry looking
	for Asprotect-generated rubbish.
*/

void ScanAspr()
{
	SetStatus("scanning... (Asprotect)");



	// REGISTRY SCAN, VARIABLE KEYS (works ok)

	char* currentkey = new char[BUFSIZE];
	char* buf = new char[BUFSIZE];
	char* buf2 = new char[BUFSIZE];
	DWORD size = BUFSIZE;
	FILETIME last;
	HKEY basekey=NULL;

	RegOpenKeyEx(HKEY_CLASSES_ROOT,"CLSID\\",0,KEY_ALL_ACCESS,&basekey);

	int i=0,j=0;
	while(RegEnumKeyEx(basekey,i,currentkey,&size,0,NULL,NULL,&last)!=ERROR_NO_MORE_ITEMS)
	{
		if (IsAsprKey(basekey,currentkey,buf))
		{
			wsprintf(buf2,"rkey::HKCR\\CLSID\\%s",currentkey);
			AddVal(ASPR,buf2);

			if (buf[0] != 0)
			{
				wsprintf(buf2,"rkey::HKCR\\TypeLib\\%s",buf);
				AddVal(ASPR,buf2);
			}
		}
		size = BUFSIZE;
		i++;
	}

	RegCloseKey(basekey);



	// REGISTRY SCAN, FIXED KEYS (works ok)

	if (RegOpenKeyEx(HKEY_CURRENT_USER,"SOFTWARE\\ASProtect\\Data",0,KEY_ALL_ACCESS,&basekey)==ERROR_SUCCESS)
	{
		AddVal(ASPR,"rkey::HKCU\\SOFTWARE\\ASProtect\\Data");
		RegCloseKey(basekey);
	}

	

	if (RegOpenKeyEx(HKEY_CURRENT_USER,"SOFTWARE\\ASProtect\\SpecData",0,KEY_ALL_ACCESS,&basekey)==ERROR_SUCCESS)
	{
		AddVal(ASPR,"rkey::HKCU\\SOFTWARE\\ASProtect\\SpecData");
		RegCloseKey(basekey);
	}



	// SCAN FINISHED

	delete[] currentkey;
	delete[] buf;
	delete[] buf2;

	SetStatusReady();
}

bool IsAsprKey(HKEY base, char* keyname, char* val)
{
	HKEY sub,sub2;
	DWORD size = BUFSIZE;
	DWORD res;

	if (RegOpenKeyEx(base,keyname,0,KEY_ALL_ACCESS,&sub) != ERROR_SUCCESS)
		return false;

	if (RegOpenKeyEx(sub,"Typelib",0,KEY_ALL_ACCESS,&sub2) != ERROR_SUCCESS)
	{
		RegCloseKey(sub);
		return false;
	}

	RegCloseKey(sub);

	if (RegQueryValueEx(sub2,"",0,NULL,(unsigned char*)val,&size) != ERROR_SUCCESS)
	{
		RegCloseKey(sub2);
		return false;
	}

	RegCloseKey(sub2);

	if (val[0] == 0) return false;

	char* buf = new char[BUFSIZE];
	size = BUFSIZE;

	wsprintf(buf,"TypeLib\\%s",val);
	if (RegOpenKeyEx(HKEY_CLASSES_ROOT,buf,0,KEY_ALL_ACCESS,&sub) != ERROR_SUCCESS)
		return false;

	res = RegEnumKey(sub,0,buf,BUFSIZE);

	if (res == ERROR_NO_MORE_ITEMS)
	{
		RegCloseKey(sub);
		return true;
	}

	RegCloseKey(sub);

	return false;
}