/*
	GRAPHICAL/FUNCTIONAL IMPLEMENTATION
	status: working ok
*/

#include <shlwapi.h>
#include "win.h"



/*
	There's nothing interesting here.
*/

HWND hwnd,hScan,hScanLog,hRemove,hStatusBar;
HINSTANCE hInstance;
char szWinName[ ]="eva++ [bender0]";
int winx=509,winy=439;
HFONT hfDefault=(HFONT)GetStockObject(DEFAULT_GUI_FONT);
HTREEITEM rooti,armai,aspri,svki,acpri,obsi,pcgi,vboxi;

void KillAllChildren(HTREEITEM father)
{
	HTREEITEM child;
	while ((child = TreeView_GetChild(hScanLog,father))!=NULL)
	{
		TreeView_DeleteItem(hScanLog,child);
	}
}

void Scan()
{
	char buf[50];
	TVITEM item;
	HTREEITEM hti = TreeView_GetSelection(hScanLog);
	item.hItem = hti;
	item.mask = TVIF_TEXT;
	item.pszText = buf;
	item.cchTextMax = 50;
	TreeView_GetItem(hScanLog,&item);

	if (!strcmp(buf,ARMANAME))
	{
		KillAllChildren(armai);
		ScanArma();
	}
	else if (!strcmp(buf,ASPRNAME))
	{
		KillAllChildren(aspri);
		ScanAspr();
	}
	else if (!strcmp(buf,SVKNAME))
	{
		KillAllChildren(svki);
		ScanSVK();
	}
	else if (!strcmp(buf,ACPRNAME))
	{
		KillAllChildren(acpri);
		ScanAcpr();
	}
	else if (!strcmp(buf,OBSNAME))
	{
		KillAllChildren(obsi);
		ScanObs();
	}
	else if (!strcmp(buf,PCGNAME))
	{
		KillAllChildren(pcgi);
		ScanPcg();
	}
	else if (!strcmp(buf,VBOXNAME))
	{
		KillAllChildren(vboxi);
		ScanVbox();
	}
	else
	{
		KillAllChildren(armai);
		KillAllChildren(aspri);
		KillAllChildren(svki);
		KillAllChildren(acpri);
		KillAllChildren(obsi);
		KillAllChildren(pcgi);
		KillAllChildren(vboxi);
		ScanArma();
		ScanAspr();
		ScanSVK();
		ScanAcpr();
		ScanObs();
		ScanPcg();
		ScanVbox();
	}

	TreeView_Expand(hScanLog,armai,TVE_EXPAND);
	TreeView_Expand(hScanLog,aspri,TVE_EXPAND);
	TreeView_Expand(hScanLog,svki,TVE_EXPAND);
	TreeView_Expand(hScanLog,acpri,TVE_EXPAND);
	TreeView_Expand(hScanLog,obsi,TVE_EXPAND);
	TreeView_Expand(hScanLog,pcgi,TVE_EXPAND);
	TreeView_Expand(hScanLog,vboxi,TVE_EXPAND);
	TreeView_Expand(hScanLog,rooti,TVE_EXPAND);
}

void KillString(char*buf)
{
	if (buf[0]=='r')
	{
		HKEY key;
		char kname[10];
		memcpy((LPVOID)kname,(LPVOID)(buf+6),4);
		kname[4]=0;
		if (!strcmp(kname,"HKCR")) key = HKEY_CLASSES_ROOT;
		if (!strcmp(kname,"HKCU")) key = HKEY_CURRENT_USER;
		if (!strcmp(kname,"HKLM")) key = HKEY_LOCAL_MACHINE;
		SHDeleteKey(key,buf+11);
		return;
	}

	if (buf[0]=='f')
	{
		memcpy((LPVOID)buf,(LPVOID)(buf+6),256);
		DeleteFile(buf);
		return;
	}
}

void KillLoop(HTREEITEM father)
{
	char buf[500];
	TVITEM item;
	HTREEITEM child;
	while ((child = TreeView_GetChild(hScanLog,father))!=NULL)
	{
		item.hItem = child;
		item.mask = TVIF_TEXT;
		item.pszText = buf;
		item.cchTextMax = 500;
		TreeView_GetItem(hScanLog,&item);
		KillString(buf);
		TreeView_DeleteItem(hScanLog,child);
	}
}

void Remove()
{
	char buf[256];
	TVITEM item;
	HTREEITEM hti = TreeView_GetSelection(hScanLog);
	item.hItem = hti;
	item.mask = TVIF_TEXT;
	item.pszText = buf;
	item.cchTextMax = 50;
	TreeView_GetItem(hScanLog,&item);

	if (!strcmp(buf,ARMANAME))
	{
		SetStatus("removing Armadillo...");
		KillLoop(armai);
		SetStatusReady();
	}
	else if (!strcmp(buf,ASPRNAME))
	{
		SetStatus("removing Asprotect...");
		KillLoop(aspri);
		SetStatusReady();
	}
	else if (!strcmp(buf,SVKNAME))
	{
		SetStatus("removing SVK...");
		KillLoop(svki);
		SetStatusReady();
	}
	else if (!strcmp(buf,ACPRNAME))
	{
		SetStatus("removing ACProtect...");
		KillLoop(acpri);
		SetStatusReady();
	}
	else if (!strcmp(buf,OBSNAME))
	{
		SetStatus("removing Obsidium...");
		KillLoop(obsi);
		SetStatusReady();
	}
	else if (!strcmp(buf,PCGNAME))
	{
		SetStatus("removing PCGuard...");
		KillLoop(pcgi);
		SetStatusReady();
	}
	else if (!strcmp(buf,VBOXNAME))
	{
		SetStatus("removing VBOX...");
		KillLoop(vboxi);
		SetStatusReady();
	}
	else if (!strcmp(buf,"All"))
	{
		SetStatus("removing everything...");
		KillLoop(armai);
		KillLoop(aspri);
		KillLoop(svki);
		KillLoop(acpri);
		KillLoop(obsi);
		KillLoop(pcgi);
		KillLoop(vboxi);
		SetStatusReady();
	}
	else if (item.hItem != NULL)
	{
		SetStatus("removing selected item");
		KillString(buf);
		TreeView_DeleteItem(hScanLog,hti);
		SetStatusReady();
	}

	Scan();
}

void SetStatusReady()
{
	SendMessage(hStatusBar,SB_SETTEXT,0,(WPARAM)"ready");
}

void SetStatus(char*text)
{
	SendMessage(hStatusBar,SB_SETTEXT,0,(WPARAM)text);
}

void InitTreeView()
{
	TVINSERTSTRUCT data;
	data.hParent=TVI_ROOT;
	data.hInsertAfter=TVI_ROOT;
	data.item.mask=TVIF_TEXT;
	data.item.pszText="All";
	rooti = (HTREEITEM)SendMessage(hScanLog,TVM_INSERTITEM,0,(LPARAM)&data);

	data.hParent=rooti;
	data.hInsertAfter=TVI_LAST;
	data.item.pszText=ARMANAME;
	armai = (HTREEITEM)SendMessage(hScanLog,TVM_INSERTITEM,0,(LPARAM)&data);
	data.item.pszText=ASPRNAME;
	aspri = (HTREEITEM)SendMessage(hScanLog,TVM_INSERTITEM,0,(LPARAM)&data);
	data.item.pszText=SVKNAME;
	svki = (HTREEITEM)SendMessage(hScanLog,TVM_INSERTITEM,0,(LPARAM)&data);
	data.item.pszText=ACPRNAME;
	acpri = (HTREEITEM)SendMessage(hScanLog,TVM_INSERTITEM,0,(LPARAM)&data);
	data.item.pszText=OBSNAME;
	obsi = (HTREEITEM)SendMessage(hScanLog,TVM_INSERTITEM,0,(LPARAM)&data);
	data.item.pszText=PCGNAME;
	pcgi = (HTREEITEM)SendMessage(hScanLog,TVM_INSERTITEM,0,(LPARAM)&data);
	data.item.pszText=VBOXNAME;
	vboxi = (HTREEITEM)SendMessage(hScanLog,TVM_INSERTITEM,0,(LPARAM)&data);
}

void AddVal(packers pack,char*val)
{
	TVINSERTSTRUCT data;
	if (pack==ARMA)
	{
		data.hParent=armai;
	}
	else if (pack==ASPR)
	{
		data.hParent=aspri;
	}
	else if (pack==SVK)
	{
		data.hParent=svki;
	}
	else if (pack==ACPR)
	{
		data.hParent=acpri;
	}
	else if (pack==OBS)
	{
		data.hParent=obsi;
	}
	else if (pack==PCG)
	{
		data.hParent=pcgi;
	}
	else if (pack==VBOX)
	{
		data.hParent=vboxi;
	}
	data.item.mask=TVIF_TEXT;
	data.item.pszText=val;
	SendMessage(hScanLog,TVM_INSERTITEM,0,(LPARAM)&data);
}

LRESULT CALLBACK WindowProc(
	HWND hwnd,
    UINT uMsg,
    WPARAM wParam,
    LPARAM lParam)
{
	switch(uMsg)
	{
		case WM_COMMAND:
			if (HIWORD(wParam)==0)
			{
				if (LOWORD(wParam)==1000)
				{
					Scan();
				}
				if (LOWORD(wParam)==1002)
				{
					Remove();
				}
			}
			break;

		case WM_CLOSE:
			ExitProcess(0);
			break;

		default:
			return DefWindowProc(hwnd,uMsg,wParam,lParam);
	}
	return 0;
}

int APIENTRY WinMain(HINSTANCE phInstance,
                     HINSTANCE phPrevInstance,
                     LPSTR     plpCmdLine,
                     int       pnCmdShow)
{
	InitCommonControls();
	hInstance=phInstance;
	BOOL bRet=true;
	MSG msg;

	WNDCLASSEX wc;

    wc.cbSize			=	sizeof(WNDCLASSEX);
    wc.style			=	CS_DBLCLKS|CS_HREDRAW|CS_VREDRAW;
    wc.lpfnWndProc		=	WindowProc;
    wc.cbClsExtra		=	0;
    wc.cbWndExtra		=	0;
    wc.hInstance		=	hInstance;
    wc.hIcon			=	LoadIcon(hInstance,"MAIN_ICON");
    wc.hCursor			=	LoadCursor(NULL,IDC_ARROW);
    wc.hbrBackground	=	(HBRUSH)COLOR_BACKGROUND;
    wc.lpszMenuName		=	NULL;
    wc.lpszClassName	=	szWinName;
    wc.hIconSm			=	LoadIcon(hInstance,"MAIN_ICON");

	if (RegisterClassEx(&wc)==0)
	{
		MessageBox(NULL,"couldn't register window class","error",0);
		return 0;
	}

	hwnd = CreateWindowEx(
		0,
		szWinName,
		szWinName,
		WS_CLIPSIBLINGS|WS_VISIBLE|WS_SYSMENU,
		GetSystemMetrics(SM_CXSCREEN)/2-(winx/2),
		GetSystemMetrics(SM_CYSCREEN)/2-(winy/2),
		winx,
		winy+2*GetSystemMetrics(SM_CYCAPTION),
		HWND_DESKTOP,
		(HMENU)NULL,
		hInstance,
		NULL
	);

	hScan = CreateWindowEx(
		WS_EX_CLIENTEDGE,
		"BUTTON",
		"scan selected",
		WS_VISIBLE|WS_CHILD,
		1,
		2,
		248,
		20,
		hwnd,
		(HMENU)1000,
		hInstance,
		NULL
	);

	SendMessage(hScan,WM_SETFONT,(WPARAM)hfDefault,(LPARAM) true);

	hRemove = CreateWindowEx(
		WS_EX_CLIENTEDGE,
		"BUTTON",
		"remove selected",
		WS_VISIBLE|WS_CHILD,
		253,
		2,
		248,
		20,
		hwnd,
		(HMENU)1002,
		hInstance,
		NULL
	);

	SendMessage(hRemove,WM_SETFONT,(WPARAM)hfDefault,(LPARAM) true);

	hScanLog = CreateWindowEx(
		WS_EX_CLIENTEDGE,
		WC_TREEVIEW,
		"",
		WS_VISIBLE | WS_CHILD | WS_BORDER | TVS_HASLINES | TVS_LINESATROOT,
		1,
		25,
		500,
		406,
		hwnd,
		(HMENU)1001,
		hInstance,
		NULL
	);

	SendMessage(hScanLog,WM_SETFONT,(WPARAM)hfDefault,(LPARAM) true);

	hStatusBar = CreateWindowEx(
		0,
		STATUSCLASSNAME,
		"",
		WS_VISIBLE | WS_CHILD,
		0,
		0,
		0,
		0,
		hwnd,
		(HMENU)1001,
		hInstance,
		NULL
	);

	SendMessage(hStatusBar,WM_SETFONT,(WPARAM)hfDefault,(LPARAM) true);
	SendMessage(hStatusBar,SB_SETMINHEIGHT,(WPARAM)(int) 25,0);
	SetStatusReady();

	InitTreeView();
	Scan();

	while( (bRet=GetMessage(&msg,NULL,0,0)) != 0) 
	{
		if (bRet==-1)
		{
			MessageBox(NULL,"fatal error. shutting down...","error",0);
			return (int)msg.wParam;
		}
		else
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int)msg.wParam;
}